
Program lab4;
uses graph,crt;

type
  mir = array [0..7,0..2] of Extended;
  ekr = array [0..7,0..1] of Extended;


Const
  xe:Extended=2;
  ye:Extended=2;   { 窠  }
  ze:Extended=2;
  d=200;           { ﭨ }

  vo : array[0..2] of real=(0,0.1,0);
  vs : array[0..2] of real=(0,0,0);
  a  : array[0..2] of real=(0,0,0);

var
  re,mo : integer;
  b,i,j : integer;
  cub,_cub,cube:mir;
  cub2:ekr;
  r,al,th,fi:extended;

 Procedure convert(cub:mir);
var i,j:integer;

begin

  r:=sqrt(ze*ze+ye*ye+xe*xe);

  for i:=0 to 7 do begin
     cube[i][0]:=-cub[i][0]*sin(th)+cub[i][1]*cos(th);
     cube[i][1]:=-cub[i][0]*cos(fi)*cos(th)-cub[i][1]*cos(fi)*sin(th)+sin(fi)*cub[i][2];
     cube[i][2]:=-cub[i][0]*sin(fi)*cos(th)-cub[i][1]*sin(fi)*sin(th)-cub[i][2]*cos(fi)+r;
     cub2[i][0]:=(cube[i][0]/(cube[i][2]))*d+640/2;
     cub2[i][1]:=(cube[i][1]/(cube[i][2]))*d+480/2;
   end;
end;

        {
Procedure povorot_x(cub:mir;f:integer;al:extended);
var i:integer;
begin
  for i:=0 to 7 do begin
      _cub[i][0]:=cub[i][0];
      _cub[i][1]:=cub[i][1]*cos(f*al)-cub[i][2]*sin(f*al);
      _cub[i][2]:=cub[i][1]*sin(f*al)+cub[i][2]*cos(f*al);
    end;
  convert(_cub);
end;
         }

Procedure povorot_y(cub:mir;f:integer;al:extended);
var i:integer;
begin
  for i:=0 to 7 do begin
      _cub[i][0]:=cub[i][0]*cos(f*al)+cub[i][2]*sin(f*al);
      _cub[i][1]:=cub[i][1];
      _cub[i][2]:=-cub[i][0]*sin(f*al)+cub[i][2]*cos(f*al);
   end;
  convert(_cub);
end;

Procedure povorot_z(cub:mir;f:integer;al:extended);
var i:integer;
begin
  for i:=0 to 7 do begin
      _cub[i][0]:=cub[i][0]*cos(f*al)-cub[i][1]*sin(f*al);
      _cub[i][1]:=cub[i][0]*sin(f*al)+cub[i][1]*cos(f*al);
      _cub[i][2]:=cub[i][2];
    end;
  convert(_cub);
end;


Procedure drawcube(cub:ekr);
begin
    line(Round(cub[0][0]),Round(cub[0][1]),Round(cub[1][0]),Round(cub[1][1]));
    line(Round(cub[0][0]),Round(cub[0][1]),Round(cub[3][0]),Round(cub[3][1]));
    line(Round(cub[0][0]),Round(cub[0][1]),Round(cub[7][0]),Round(cub[7][1]));
    line(Round(cub[1][0]),Round(cub[1][1]),Round(cub[2][0]),Round(cub[2][1]));
    line(Round(cub[1][0]),Round(cub[1][1]),Round(cub[6][0]),Round(cub[6][1]));
    line(Round(cub[2][0]),Round(cub[2][1]),Round(cub[3][0]),Round(cub[3][1]));
    line(Round(cub[2][0]),Round(cub[2][1]),Round(cub[5][0]),Round(cub[5][1]));
    line(Round(cub[6][0]),Round(cub[6][1]),Round(cub[5][0]),Round(cub[5][1]));
    line(Round(cub[6][0]),Round(cub[6][1]),Round(cub[7][0]),Round(cub[7][1]));
    line(Round(cub[4][0]),Round(cub[4][1]),Round(cub[5][0]),Round(cub[5][1]));
    line(Round(cub[4][0]),Round(cub[4][1]),Round(cub[7][0]),Round(cub[7][1]));
    line(Round(cub[4][0]),Round(cub[4][1]),Round(cub[3][0]),Round(cub[3][1]));
end;


begin

  cub[0][0]:=-1;cub[1][0]:= 1;cub[2][0]:= 1;cub[3][0]:=-1;
  cub[0][1]:=-1;cub[1][1]:=-1;cub[2][1]:=-1;cub[3][1]:=-1;
  cub[0][2]:=-1;cub[1][2]:=-1;cub[2][2]:= 1;cub[3][2]:= 1;
  cub[4][0]:=-1;cub[5][0]:= 1;cub[6][0]:= 1;cub[7][0]:=-1;
  cub[4][1]:= 1;cub[5][1]:= 1;cub[6][1]:= 1;cub[7][1]:= 1;
  cub[4][2]:= 1;cub[5][2]:= 1;cub[6][2]:=-1;cub[7][2]:=-1;

  vs[0]:=sqrt(vo[2]*vo[2]+vo[1]*vo[1]+vo[0]*vo[0]);
  if (vs[0]=0) then begin
     vs[1]:=0;
     vs[2]:=0;
   end;
initgraph(re,mo,'');

Line(310,240,330,240);
Line(320,230,320,250);
SetColor(14);


for i:=0 to 7 do
    for j:=0 to 3 do begin
      _cub[i][j]:=cub[i][j];
      end;

setwritemode(1);
setcolor(15);
al:=0.1;

repeat

  povorot_y(cub,1,al); cub:=_cub;


  drawcube(cub2);

  delay(10000);
  drawcube(cub2);



until keypressed;
closegraph;
end.